;#########################################################################
;        Include files

    include windows.inc
    include kernel32.inc
    include user32.inc
;    include Comctl32.inc
;    include shell32.inc
;    include ComDlg32.inc
;    include Gdi32.inc

    include Masm32.inc

;#########################################################################
;        Libraries

    includelib kernel32.lib
    includelib user32.lib
;    includelib Comctl32.lib
;    includelib shell32.lib
;    includelib ComDlg32.lib
;    includelib Gdi32.lib

    includelib Masm32.lib

;#########################################################################
;        RadASM Add In Include

    include \RadASM\Masm\Inc\radasm.inc

;#########################################################################
;        VKim's Debug

;    include \RadASM\masm\inc\debug.inc
;    includelib \RadASM\masm\lib\debug.lib
;
;    DBGWIN_DEBUG_ON = 1        ; include debug info into the program
;    DBGWIN_EXT_INFO = 0        ; include extra debug info into the program

;#########################################################################
;        Prototypes

    DLLProc                 PROTO :DWORD, :DWORD, :DWORD, :DWORD
    InstallDLL              PROTO :DWORD, :DWORD
    GetOptions              PROTO

    DialogProc              PROTO :DWORD, :DWORD, :DWORD, :DWORD

    GetManifestFile         PROTO
    ParseManifest           PROTO
    LoadManifest            PROTO
    SaveManifest            PROTO
    DeleteManifest          PROTO

    IDD_DIALOG1 equ 101
    IDC_EDIT1   equ 200
    IDC_EDIT2   equ 201
    IDC_EDIT3   equ 202
    IDC_EDIT4   equ 203
    IDC_EDIT5   equ 204

ifndef ADDINOPT
    ADDINOPT struct
        lpStr   dd ?    ;Pointer to CheckBox text
        nAnd    dd ?    ;Option AND value
        nOr     dd ?    ;Option OR value
    ADDINOPT ends
endif

.const
    AddinOptions        ADDINOPT <offset szAddinOptText1,1,1>   ;Enabled?
                        ADDINOPT <offset szAddinOptText2,2,2>   ;Use RC script?
                        ADDINOPT <offset szAddinOptText3,4,4>   ;Use Manifest file?
                        ADDINOPT <offset szAddinOptText4,8,8>   ;Use Unicode?
                        ADDINOPT <offset szAddinOptText5,16,16> ;Autorun on project open?
                        ADDINOPT <0,0,0>                        ;End of ADDINOPT array

    szNULL              db 0,0
    szDot               db ".",0
    sz7                 db "7",0
    sz1                 db "1",0        ;Id for EXE
    sz2                 db "2",0        ;Id for DLL
    sz123               db "123",0      ;Id for CPL
    szAddinOptText1     db "Enable AddIn",0
    szAddinOptText2     db "Add to resource script",0
    szAddinOptText3     db "Use manifest file",0
    szAddinOptText4     db "Use Unicode",0
    szAddinOptText5     db "Autorun on project open",0
    szWarning           db "Warning",0
    szError             db "Error",0
    szTamper            db "The generated code in the resource script seems to have been edited.",13,10
                        db "If the addin can't properly evaluate wich part of the script to replace, you might loose some data.",13,10
                        db "Are you sure you want to continue?",0
    szDelFile           db "The addin is configured NOT to use a manifest file, however one was found.",13,10
                        db "Should it be deleted?",0
    szDelCode           db "The addin is configured NOT to insert code in the resource script, however such code was found.",13,10
                        db "Should it be removed?",0
    szReadError         db "There was an unexpected error while reading the resource script.",13,10
                        db "The resource script was NOT updated.",0
    szWriteError        db "There was an unexpected error while writing the resource script (perhaps the disk is full?).",13,10
                        db "The resource script was NOT updated.",0
    szWriteError2       db "There was an unexpected error while writing the manifest file (perhaps the disk is full?).",13,10
                        db "The manifest file was NOT updated.",0
    szUnknownError      db "An unknown error occured. Operation aborted.",0
    szMenuItem          db "XP Manifest",0
    szExe               db "Exe",0
    szDll               db "Dll",0
    szCpl               db "Cpl",0
    szAMF               db "AMF",0
    szManifest          db "Manifest",0
    szVerInf            db "VerInf",0
    szProject           db "Project",0
    szType              db "Type",0
    szDescription       db "Description",0
    szMakeFiles         db "MakeFiles",0
    szDeleteFile        db "DeleteFile",0
    szDeleteCode        db "DeleteCode",0
    szDllProject        db "Dll Project",0
    szCompanyName       db "CompanyName",0
    szProductName       db "ProductName",0
    szInternalName      db "InternalName",0
    szFileDescription   db "FileDescription",0
    szProductVersion    db "ProductVersion",0
    szDefVer            db "1.0.0.0",0
    szDefCompany        db "Company",0
    szDefProduct        db "Product",0
    szDefInternal       db "Name",0
    szDefDesc           db "You application description here.",0
    szRCSeparator       db "//; This part was generated by RadAsm (AddManifest AddIn). Do not edit!",13,10,0

; Text inserted in the resource script when a file is used.
Manifest_Include1 db ' 24 DISCARDABLE "'
Manifest_Include2 db '"',13,10

; Text inserted in the resource script when no file is used.
Manifest_Add0 label byte
db ' 24 DISCARDABLE',13,10
db 'BEGIN',13,10
Manifest_AddSize0 equ $ - offset Manifest_Add0
Manifest_Add1 label byte
db 'L"<?xml version=""1.0"" encoding=""UTF-8"" standalone=""yes""?>',13,10
db '<assembly xmlns=""urn:schemas-microsoft-com:asm.v1"" manifestVersion=""1.0"">',13,10
db '<assemblyIdentity',13,10
db '	version=""'
Manifest_AddSize1 equ $ - offset Manifest_Add1
Manifest_Add2 label byte
db '""',13,10
db '	processorArchitecture=""X86""',13,10
db '	name=""'
Manifest_AddSize2 equ $ - offset Manifest_Add2
Manifest_Add3 label byte
db '""',13,10
db '	type=""win32""',13,10
db '/>',13,10
db '<description>'
Manifest_AddSize3 equ $ - offset Manifest_Add3
Manifest_Add4 label byte
db '</description>',13,10
db '<dependency>',13,10
db '	<dependentAssembly>',13,10
db '		<assemblyIdentity',13,10
db '			type=""win32""',13,10
db '			name=""Microsoft.Windows.Common-Controls""',13,10
db '			version=""6.0.0.0""',13,10
db '			processorArchitecture=""X86""',13,10
db '			publicKeyToken=""6595b64144ccf1df""',13,10
db '			language=""*""',13,10
db '		/>',13,10
db '	</dependentAssembly>',13,10
db '</dependency>',13,10
db '</assembly>"',13,10
db 'END',13,10
Manifest_AddSize4 equ $ - offset Manifest_Add4

; Text written to the manifest file. 
Manifest_Data1 label byte
db '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>',13,10
db '<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">',13,10
db '<assemblyIdentity',13,10
db '	version="'
Manifest_Size1 equ $ - offset Manifest_Data1
Manifest_Data2 label byte
db '"',13,10
db '	processorArchitecture="X86"',13,10
db '	name="'
Manifest_Size2 equ $ - offset Manifest_Data2
Manifest_Data3 label byte
db '"',13,10
db '	type="win32"',13,10
db '/>',13,10
db '<description>'
Manifest_Size3 equ $ - offset Manifest_Data3
Manifest_Data4 label byte
db '</description>',13,10
db '<dependency>',13,10
db '	<dependentAssembly>',13,10
db '		<assemblyIdentity',13,10
db '			type="win32"',13,10
db '			name="Microsoft.Windows.Common-Controls"',13,10
db '			version="6.0.0.0"',13,10
db '			processorArchitecture="X86"',13,10
db '			publicKeyToken="6595b64144ccf1df"',13,10
db '			language="*"',13,10
db '		/>',13,10
db '	</dependentAssembly>',13,10
db '</dependency>',13,10
db '</assembly>'
Manifest_Size4 equ $ - offset Manifest_Data4

.data?

    hInstance           dd ?    ;Dll's module handle
    lpHandles           dd ?    ;Pointer to handles struct
    lpProc              dd ?    ;Pointer to proc struct
    lpData              dd ?    ;Pointer to data struct
    lpProject           dd ?    ;Pointer to project file
    hOut                dd ?    ;Handle of output window
    IDAddIn             dd ?    ;Unique ID for this AddIn
    fOptions            dd ?    ;AddIn option bits
    hMod                dd ?    ;RadAsm module handle
    hSubMenu            dd ?    ;"Project" submenu
    hdlg                dd ?    ;Handle to our dialog box

    Manifest_Name       db 256 dup (?)  ;Company.Product.Internal
    Manifest_Ver        db 256 dup (?)
    Manifest_Desc       db 256 dup (?)
    Manifest_Company    db 256 dup (?)
    Manifest_Product    db 256 dup (?)
    Manifest_Internal   db 256 dup (?)

    Manifest_File       db MAX_PATH dup (?)
    Manifest_Path       db (MAX_PATH * 2) dup (?) ;Project path + Manifest file name
    Manifest_RCfile     db MAX_PATH dup (?)
    Manifest_Tempfile   db MAX_PATH dup (?)
